## l2tpns 2.0.8

=== Makefile ===
DESTDIR =
bindir = /usr/sbin
etcdir = /etc/l2tpns
libdir = /usr/lib/l2tpns
man5dir = /usr/share/man/man5
man8dir = /usr/share/man/man8
statedir = /var/lib/l2tpns

DEFINES =
DEFINES += -DSTATISTICS
DEFINES += -DSTAT_CALLS
DEFINES += -DRINGBUFFER
DEFINES += -DBGP
DEFINES += -DLIBDIR='"$(libdir)"'
DEFINES += -DETCDIR='"$(etcdir)"'
DEFINES += -DSTATEDIR='"$(statedir)"'

OPTIM = -g
OPTIM += -O3
OPTIM += -funroll-loops
OPTIM += -fomit-frame-pointer
OPTIM += -finline-functions
#OPTIM += -fstrength-reduce

CC = gcc
LD = gcc
INCLUDES = -I.
CPPFLAGS = $(INCLUDES) $(DEFINES)
CFLAGS = -Wall $(OPTIM)
LDFLAGS =
LDLIBS =
INSTALL = install -c -D -o root -g root

l2tpns.LIBS = -lm -lcli -ldl

OBJS = arp.o bgp.o cli.o cluster.o constants.o control.o icmp.o \
    l2tpns.o ll.o md5.o ppp.o radius.o tbf.o util.o

PROGRAMS = l2tpns nsctl
PLUGINS = garden.so throttlectl.so autothrottle.so snoopctl.so \
    autosnoop.so stripdomain.so setrxspeed.so

TESTS = generateload bounce 

all: programs plugins tests
programs: $(PROGRAMS)
plugins: $(PLUGINS)
tests: $(TESTS)

clean:
	rm -f *.o test/*.o $(PROGRAMS) $(PLUGINS) $(TESTS) Makefile.tmp Makefile.bak

depend:
	(sed -n 'p; /^## Dependencies: (autogenerated) ##/q' Makefile && \
	    gcc -MM $(CPPFLAGS) $(OBJS:.o=.c) && \
	    gcc -MM $(CPPFLAGS) $(PLUGINS:.so=.c) | sed 's/\.o/.so/') >Makefile.tmp
	mv Makefile Makefile.bak
	mv Makefile.tmp Makefile

l2tpns:	$(OBJS)
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS) $($@.LIBS)

nsctl:	nsctl.o control.o
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS) $($@.LIBS)

generateload:	test/generateload.o
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS) $($@.LIBS)

bounce:	test/bounce.o
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS) $($@.LIBS)

%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $<

%.so: %.c
	$(CC) -fPIC -shared $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $<

# install config files only if a startup-config does not exist yet
# this does not interfere when building rpms or debs and makes
# fast upgrading via make install possible

install: all
	$(INSTALL) -m 0755 l2tpns $(DESTDIR)$(bindir)/l2tpns
	$(INSTALL) -m 0755 nsctl $(DESTDIR)$(bindir)/nsctl

	$(INSTALL) -m 0644 Docs/startup-config.5 $(DESTDIR)$(man5dir)/startup-config.5
	$(INSTALL) -m 0644 Docs/l2tpns.8 $(DESTDIR)$(man8dir)/l2tpns.8
	$(INSTALL) -m 0644 Docs/nsctl.8 $(DESTDIR)$(man8dir)/nsctl.8

	gzip $(DESTDIR)$(man5dir)/*.5 $(DESTDIR)$(man8dir)/*.8

	@if [ -f $(DESTDIR)$(etcdir)/startup-config ]; then \
		echo '***' Installing default config files in $(DESTDIR)$(etcdir) as .defaults; \
		suffix=.default; \
	else \
		echo '***' Installing default config files in $(DESTDIR)$(etcdir) - remember to adjust them; \
		suffix=; \
	fi; \

	$(INSTALL) -m 0600 etc/startup-config.default $(DESTDIR)$(etcdir)/startup-config$$suffix; \
	$(INSTALL) -m 0644 etc/ip_pool.default $(DESTDIR)$(etcdir)/ip_pool$$suffix; \
	$(INSTALL) -m 0600 etc/users.default $(DESTDIR)$(etcdir)/users$$suffix

	for plugin in $(PLUGINS); do \
		$(INSTALL) -m 0755 $$plugin $(DESTDIR)$(libdir)/$$plugin; \
	done

	if [ -z $(DESTDIR) ] && [ ! -e /dev/net/tun ]; then \
		mkdir /dev/net; \
		mknod /dev/net/tun c 10 200; \
	fi

.PHONY: all clean depend install

## Dependencies: (autogenerated) ##
arp.o: arp.c l2tpns.h
bgp.o: bgp.c l2tpns.h bgp.h util.h
cli.o: cli.c l2tpns.h util.h cluster.h tbf.h ll.h bgp.h
cluster.o: cluster.c l2tpns.h cluster.h util.h tbf.h bgp.h
constants.o: constants.c constants.h
control.o: control.c l2tpns.h control.h
icmp.o: icmp.c l2tpns.h
l2tpns.o: l2tpns.c md5.h l2tpns.h cluster.h plugin.h ll.h constants.h \
  control.h util.h tbf.h bgp.h
ll.o: ll.c ll.h
md5.o: md5.c md5.h
ppp.o: ppp.c l2tpns.h constants.h plugin.h util.h tbf.h cluster.h
radius.o: radius.c md5.h constants.h l2tpns.h plugin.h util.h
tbf.o: tbf.c l2tpns.h util.h tbf.h
util.o: util.c l2tpns.h bgp.h
garden.so: garden.c l2tpns.h plugin.h control.h
throttlectl.so: throttlectl.c l2tpns.h plugin.h control.h
autothrottle.so: autothrottle.c l2tpns.h plugin.h
snoopctl.so: snoopctl.c l2tpns.h plugin.h control.h
autosnoop.so: autosnoop.c l2tpns.h plugin.h
stripdomain.so: stripdomain.c l2tpns.h plugin.h
setrxspeed.so: setrxspeed.c l2tpns.h plugin.h

## l2tpns 2.0.14

=== Makefile ===
--- 
+++ 
@@ -7,15 +7,12 @@
 statedir = /var/lib/l2tpns
 
 DEFINES =
-DEFINES += -DSTATISTICS
-DEFINES += -DSTAT_CALLS
-DEFINES += -DRINGBUFFER
-DEFINES += -DBGP
 DEFINES += -DLIBDIR='"$(libdir)"'
 DEFINES += -DETCDIR='"$(etcdir)"'
 DEFINES += -DSTATEDIR='"$(statedir)"'
 
-OPTIM = -g
+OPTIM =
+OPTIM += -g
 OPTIM += -O3
 OPTIM += -funroll-loops
 OPTIM += -fomit-frame-pointer
@@ -33,14 +30,21 @@
 
 l2tpns.LIBS = -lm -lcli -ldl
 
-OBJS = arp.o bgp.o cli.o cluster.o constants.o control.o icmp.o \
-    l2tpns.o ll.o md5.o ppp.o radius.o tbf.o util.o
+OBJS = arp.o cli.o cluster.o constants.o control.o icmp.o l2tpns.o \
+    ll.o md5.o ppp.o radius.o tbf.o util.o
 
 PROGRAMS = l2tpns nsctl
 PLUGINS = garden.so throttlectl.so autothrottle.so snoopctl.so \
     autosnoop.so stripdomain.so setrxspeed.so
 
 TESTS = generateload bounce 
+
+DEFINES += -DSTATISTICS
+DEFINES += -DSTAT_CALLS
+DEFINES += -DRINGBUFFER
+
+DEFINES += -DBGP
+OBJS += bgp.o
 
 all: programs plugins tests
 programs: $(PROGRAMS)
@@ -87,7 +91,7 @@
 	$(INSTALL) -m 0644 Docs/l2tpns.8 $(DESTDIR)$(man8dir)/l2tpns.8
 	$(INSTALL) -m 0644 Docs/nsctl.8 $(DESTDIR)$(man8dir)/nsctl.8
 
-	gzip $(DESTDIR)$(man5dir)/*.5 $(DESTDIR)$(man8dir)/*.8
+	gzip --best $(DESTDIR)$(man5dir)/*.5 $(DESTDIR)$(man8dir)/*.8
 
 	@if [ -f $(DESTDIR)$(etcdir)/startup-config ]; then \
 		echo '***' Installing default config files in $(DESTDIR)$(etcdir) as .defaults; \
@@ -114,7 +118,6 @@
 
 ## Dependencies: (autogenerated) ##
 arp.o: arp.c l2tpns.h
-bgp.o: bgp.c l2tpns.h bgp.h util.h
 cli.o: cli.c l2tpns.h util.h cluster.h tbf.h ll.h bgp.h
 cluster.o: cluster.c l2tpns.h cluster.h util.h tbf.h bgp.h
 constants.o: constants.c constants.h
@@ -128,6 +131,7 @@
 radius.o: radius.c md5.h constants.h l2tpns.h plugin.h util.h
 tbf.o: tbf.c l2tpns.h util.h tbf.h
 util.o: util.c l2tpns.h bgp.h
+bgp.o: bgp.c l2tpns.h bgp.h util.h
 garden.so: garden.c l2tpns.h plugin.h control.h
 throttlectl.so: throttlectl.c l2tpns.h plugin.h control.h
 autothrottle.so: autothrottle.c l2tpns.h plugin.h

## l2tpns 2.0.22

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 LD = gcc
 INCLUDES = -I.
 CPPFLAGS = $(INCLUDES) $(DEFINES)
-CFLAGS = -Wall $(OPTIM)
+CFLAGS = -Wall -Wno-format-zero-length $(OPTIM)
 LDFLAGS =
 LDLIBS =
 INSTALL = install -c -D -o root -g root

## l2tpns 2.2.1

=== Makefile ===
DESTDIR =
bindir = /usr/sbin
etcdir = /etc/l2tpns
libdir = /usr/lib/l2tpns
man5dir = /usr/share/man/man5
man8dir = /usr/share/man/man8
statedir = /var/lib/l2tpns

DEFINES =
DEFINES += -DLIBDIR='"$(libdir)"'
DEFINES += -DETCDIR='"$(etcdir)"'

OPTIM =
OPTIM += -g
OPTIM += -O3

CC = gcc
LD = gcc
INCLUDES = -I.
CPPFLAGS = $(INCLUDES) $(DEFINES)
CFLAGS = -Wall -Wformat-security -Wno-format-zero-length $(OPTIM)
LDFLAGS =
LDLIBS =
INSTALL = install -c -D -o root -g root

l2tpns.LIBS = -lm -lcli -ldl

OBJS = arp.o cli.o cluster.o constants.o control.o icmp.o l2tpns.o \
    ll.o md5.o ppp.o radius.o tbf.o util.o

PROGRAMS = l2tpns nsctl
PLUGINS = autosnoop.so autothrottle.so garden.so sessionctl.so \
    setrxspeed.so snoopctl.so stripdomain.so throttlectl.so

DEFINES += -DSTATISTICS
DEFINES += -DSTAT_CALLS
DEFINES += -DRINGBUFFER

ifneq (2.4, $(shell uname -r | perl -pe 's/^(\d+\.\d+).*/$$1/'))
 DEFINES += -DHAVE_EPOLL
endif

DEFINES += -DBGP
OBJS += bgp.o

all: programs plugins
programs: $(PROGRAMS)
plugins: $(PLUGINS)

clean:
	rm -f *.o test/*.o $(PROGRAMS) $(PLUGINS) Makefile.tmp Makefile.bak

depend:
	(sed -n 'p; /^## Dependencies: (autogenerated) ##/q' Makefile && \
	    gcc -MM $(CPPFLAGS) $(OBJS:.o=.c) && \
	    gcc -MM $(CPPFLAGS) $(PLUGINS:.so=.c) | sed 's/\.o/.so/') >Makefile.tmp
	mv Makefile Makefile.bak
	mv Makefile.tmp Makefile

l2tpns: $(OBJS)
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS) $($@.LIBS)

nsctl: nsctl.o control.o
	$(LD) $(LDFLAGS) -o $@ $^ $(LDLIBS) $($@.LIBS)

%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $<

%.so: %.c
	$(CC) -fPIC -shared $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $<

install: all
	$(INSTALL) -m 0755 l2tpns $(DESTDIR)$(bindir)/l2tpns
	$(INSTALL) -m 0755 nsctl $(DESTDIR)$(bindir)/nsctl

	$(INSTALL) -m 0644 Docs/startup-config.5 $(DESTDIR)$(man5dir)/startup-config.5
	$(INSTALL) -m 0644 Docs/l2tpns.8 $(DESTDIR)$(man8dir)/l2tpns.8
	$(INSTALL) -m 0644 Docs/nsctl.8 $(DESTDIR)$(man8dir)/nsctl.8

	gzip --best --force $(DESTDIR)$(man5dir)/*.5 $(DESTDIR)$(man8dir)/*.8

	@for config in startup-config users ip_pool; \
	do \
	    suffix=; \
	    mode=0600; [ $$config = ip_pool ] && mode=0644; \
	    if [ -f $(DESTDIR)$(etcdir)/$$config ]; \
	    then \
	    	cmp -s etc/$$config.default $(DESTDIR)$(etcdir)/$$config && continue; \
		suffix=.default; \
	    fi; \
	    echo $(INSTALL) -m $$mode etc/$$config.default $(DESTDIR)$(etcdir)/$$config$$suffix; \
	    $(INSTALL) -m $$mode etc/$$config.default $(DESTDIR)$(etcdir)/$$config$$suffix; \
	done

	@for plugin in $(PLUGINS); \
	do \
		echo $(INSTALL) -m 0755 $$plugin $(DESTDIR)$(libdir)/$$plugin; \
		$(INSTALL) -m 0755 $$plugin $(DESTDIR)$(libdir)/$$plugin; \
	done

	@if [ -z $(DESTDIR) ] && [ ! -e /dev/net/tun ]; \
	then \
		mkdir /dev/net; \
		echo mknod /dev/net/tun c 10 200; \
		mknod /dev/net/tun c 10 200; \
	fi

.PHONY: all clean depend install

## Dependencies: (autogenerated) ##
arp.o: arp.c l2tpns.h
cli.o: cli.c l2tpns.h constants.h util.h cluster.h tbf.h ll.h bgp.h
cluster.o: cluster.c l2tpns.h cluster.h util.h tbf.h bgp.h
constants.o: constants.c constants.h
control.o: control.c l2tpns.h control.h
icmp.o: icmp.c l2tpns.h
l2tpns.o: l2tpns.c md5.h l2tpns.h cluster.h plugin.h ll.h constants.h \
  control.h util.h tbf.h bgp.h
ll.o: ll.c ll.h
md5.o: md5.c md5.h
ppp.o: ppp.c l2tpns.h constants.h plugin.h util.h tbf.h cluster.h
radius.o: radius.c md5.h constants.h l2tpns.h plugin.h util.h cluster.h
tbf.o: tbf.c l2tpns.h util.h tbf.h
util.o: util.c l2tpns.h bgp.h
bgp.o: bgp.c l2tpns.h bgp.h util.h
autosnoop.so: autosnoop.c l2tpns.h plugin.h
autothrottle.so: autothrottle.c l2tpns.h plugin.h
garden.so: garden.c l2tpns.h plugin.h control.h
sessionctl.so: sessionctl.c l2tpns.h plugin.h control.h
setrxspeed.so: setrxspeed.c l2tpns.h plugin.h
snoopctl.so: snoopctl.c l2tpns.h plugin.h control.h
stripdomain.so: stripdomain.c l2tpns.h plugin.h
throttlectl.so: throttlectl.c l2tpns.h plugin.h control.h

=== debian/changelog ===
l2tpns (2.2.1-2) unstable; urgency=low

  * Fix log buffer overrun, thanks to Dave Reeve (closes: #817837)
  * Add /lib/lsb/init-functions to init script.

 -- Jonathan McDowell <noodles@earth.li>  Tue, 05 Jul 2016 10:48:12 +0100

l2tpns (2.2.1-1) unstable; urgency=low

  * New upstream release.
  * Enabled hardened build flags, thanks Moritz Muehlenhoff (closes: #657846)
  * Packaging updates
    * Move to 3.0 (quilt) source format
    * Bump DH compat level to 8
  * Acknowledge NMU (closes: #468889)
  * Fix ordering of stdio.h/syslog.h includes (closes: #707385)
  * Create accounting_dir in init script if necessary (closes: #418156)
  * Bump Standards-Version to 3.9.4.0
    * Add build-arch/build-indep targets to debian/rules

 -- Jonathan McDowell <noodles@earth.li>  Tue, 04 Jun 2013 20:23:37 -0700

l2tpns (2.1.21-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Added LSB formatted dependency info in init.d script (closes: #468889)

 -- Peter Eisentraut <petere@debian.org>  Wed, 02 Apr 2008 01:58:55 +0200

l2tpns (2.1.21-1) unstable; urgency=high

  * New upstream release.
  * Fixes potential remote code execution; hence urgency=high

 -- Jonathan McDowell <noodles@earth.li>  Tue, 05 Dec 2006 16:52:54 +0000

l2tpns (2.1.19-1) unstable; urgency=low

  * New upstream release.
  * Add debian/watch file.
  * Bump Standards-Version to 3.7.2.0 (no changes).

 -- Jonathan McDowell <noodles@earth.li>  Sat, 22 Jul 2006 14:11:14 +0100

l2tpns (2.1.16-1) unstable; urgency=low

  * New upstream release.

 -- Jonathan McDowell <noodles@earth.li>  Tue, 21 Mar 2006 10:43:11 +0000

l2tpns (2.1.15-1) unstable; urgency=low

  * New upstream release.

 -- Jonathan McDowell <noodles@earth.li>  Tue, 20 Dec 2005 11:00:23 +0000

l2tpns (2.1.10-1) unstable; urgency=low

  * New upstream release.

 -- Jonathan McDowell <noodles@earth.li>  Sun, 13 Nov 2005 17:49:49 +0000

l2tpns (2.1.8-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.6.2.0 (no changes).

 -- Jonathan McDowell <noodles@earth.li>  Tue, 27 Sep 2005 17:20:19 +0100

l2tpns (2.1.3-1) unstable; urgency=low

  * New upstream release.
 
 -- Jonathan McDowell <noodles@earth.li>  Wed, 24 Aug 2005 13:05:42 +0100

l2tpns (2.0.22-1) unstable; urgency=low

  * New upstream release; last of the 2.0 releases as I plan to upload
    2.1.1 once I've tested it in production myself.

 -- Jonathan McDowell <noodles@earth.li>  Thu, 23 Jun 2005 13:41:57 +0100

l2tpns (2.0.14-1) unstable; urgency=low

  * New upstream release.
  * Tidy up spelling in Description.
  * Make lintian happy by lowering case of Layer 2.

 -- Jonathan McDowell <noodles@earth.li>  Thu, 06 Jan 2005 14:22:33 +0000

l2tpns (2.0.8-1) unstable; urgency=low

  * Initial Debian upload. (closes: #280675)

 -- Jonathan McDowell <noodles@earth.li>  Fri, 26 Nov 2004 10:27:01 +0000

=== debian/control ===
Source: l2tpns
Section: net
Priority: optional
Maintainer: Jonathan McDowell <noodles@earth.li>
Build-Depends: debhelper (>> 8), libcli-dev (>> 1.8.5)
Standards-Version: 3.9.4.0

Package: l2tpns
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: layer 2 tunnelling protocol network server (LNS)
 l2tpns is a daemon designed to terminate large volumes of layer 2
 tunnelling protocol (RFC 2661: L2TP) sessions.
 .
 The daemon supports up to 65535 sessions plus features such as rate
 limiting, walled garden, usage accounting, and clustering (for both
 load-sharing and redundancy).
 .
 Note that only the LNS side of the L2TP protocol is implemented, for
 a more complete L2TP implementation see the l2tpd package.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	#/usr/bin/docbook-to-man debian/l2tpns.sgml > l2tpns.1

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/l2tpns
	install -D -m 644 -o root -g root etc/l2tpns.logrotate \
		$(CURDIR)/debian/l2tpns/etc/logrotate.d/l2tpns


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installlogrotate
#	dh_installpam
	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
	dh_installchangelogs Changes
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## l2tpns 2.3.1

=== Makefile ===
--- 
+++ 
@@ -18,15 +18,15 @@
 LD = gcc
 INCLUDES = -I.
 CPPFLAGS = $(INCLUDES) $(DEFINES)
-CFLAGS = -Wall -Wformat-security -Wno-format-zero-length $(OPTIM)
+CFLAGS = -Wall -Wformat-security $(OPTIM)
 LDFLAGS =
 LDLIBS =
 INSTALL = install -c -D -o root -g root
 
-l2tpns.LIBS = -lm -lcli -ldl
+l2tpns.LIBS = -lcli -ldl
 
 OBJS = arp.o cli.o cluster.o constants.o control.o icmp.o l2tpns.o \
-    ll.o md5.o ppp.o radius.o tbf.o util.o
+    ll.o md5.o ppp.o radius.o tbf.o util.o pppoe.o l2tplac.o dhcp6.o ipv6_u.o
 
 PROGRAMS = l2tpns nsctl
 PLUGINS = autosnoop.so autothrottle.so garden.so sessionctl.so \
@@ -108,26 +108,35 @@
 .PHONY: all clean depend install
 
 ## Dependencies: (autogenerated) ##
-arp.o: arp.c l2tpns.h
-cli.o: cli.c l2tpns.h constants.h util.h cluster.h tbf.h ll.h bgp.h
-cluster.o: cluster.c l2tpns.h cluster.h util.h tbf.h bgp.h
+arp.o: arp.c dhcp6.h l2tpns.h
+cli.o: cli.c dhcp6.h l2tpns.h constants.h util.h cluster.h tbf.h ll.h \
+ bgp.h l2tplac.h
+cluster.o: cluster.c dhcp6.h l2tpns.h cluster.h util.h tbf.h pppoe.h \
+ bgp.h
 constants.o: constants.c constants.h
-control.o: control.c l2tpns.h control.h
-icmp.o: icmp.c l2tpns.h
-l2tpns.o: l2tpns.c md5.h l2tpns.h cluster.h plugin.h ll.h constants.h \
-  control.h util.h tbf.h bgp.h
+control.o: control.c dhcp6.h l2tpns.h control.h
+icmp.o: icmp.c dhcp6.h l2tpns.h ipv6_u.h
+l2tpns.o: l2tpns.c md5.h dhcp6.h l2tpns.h cluster.h plugin.h ll.h \
+ constants.h control.h util.h tbf.h bgp.h l2tplac.h pppoe.h
 ll.o: ll.c ll.h
 md5.o: md5.c md5.h
-ppp.o: ppp.c l2tpns.h constants.h plugin.h util.h tbf.h cluster.h
-radius.o: radius.c md5.h constants.h l2tpns.h plugin.h util.h cluster.h
-tbf.o: tbf.c l2tpns.h util.h tbf.h
-util.o: util.c l2tpns.h bgp.h
-bgp.o: bgp.c l2tpns.h bgp.h util.h
-autosnoop.so: autosnoop.c l2tpns.h plugin.h
-autothrottle.so: autothrottle.c l2tpns.h plugin.h
-garden.so: garden.c l2tpns.h plugin.h control.h
-sessionctl.so: sessionctl.c l2tpns.h plugin.h control.h
-setrxspeed.so: setrxspeed.c l2tpns.h plugin.h
-snoopctl.so: snoopctl.c l2tpns.h plugin.h control.h
-stripdomain.so: stripdomain.c l2tpns.h plugin.h
-throttlectl.so: throttlectl.c l2tpns.h plugin.h control.h
+ppp.o: ppp.c dhcp6.h l2tpns.h constants.h plugin.h util.h tbf.h cluster.h \
+ l2tplac.h pppoe.h
+radius.o: radius.c md5.h constants.h dhcp6.h l2tpns.h plugin.h util.h \
+ cluster.h l2tplac.h pppoe.h
+tbf.o: tbf.c dhcp6.h l2tpns.h util.h tbf.h
+util.o: util.c dhcp6.h l2tpns.h bgp.h
+pppoe.o: pppoe.c dhcp6.h l2tpns.h cluster.h constants.h md5.h util.h
+l2tplac.o: l2tplac.c md5.h dhcp6.h l2tpns.h util.h cluster.h l2tplac.h \
+ pppoe.h
+dhcp6.o: dhcp6.c dhcp6.h l2tpns.h ipv6_u.h
+ipv6_u.o: ipv6_u.c ipv6_u.h
+bgp.o: bgp.c dhcp6.h l2tpns.h bgp.h util.h
+autosnoop.so: autosnoop.c dhcp6.h l2tpns.h plugin.h
+autothrottle.so: autothrottle.c dhcp6.h l2tpns.h plugin.h
+garden.so: garden.c dhcp6.h l2tpns.h plugin.h control.h
+sessionctl.so: sessionctl.c dhcp6.h l2tpns.h plugin.h control.h
+setrxspeed.so: setrxspeed.c dhcp6.h l2tpns.h plugin.h
+snoopctl.so: snoopctl.c dhcp6.h l2tpns.h plugin.h control.h
+stripdomain.so: stripdomain.c dhcp6.h l2tpns.h plugin.h
+throttlectl.so: throttlectl.c dhcp6.h l2tpns.h plugin.h control.h

=== debian/changelog ===
l2tpns (2.3.1-1) unstable; urgency=medium

  [ Julien Rabier ]
  * New upstream version 2.3.1
  * d/init.d:
    + Cleanup usage of detach flag (should not be used with SystemD)
    + Fix SystemV, SIGQUIT signal sends to l2tpns causes to flush all
      sessions even in cluster mode. A normal SIGTERM should be used.
  * d/service: Use upstream SystemD unit file

  [ Samuel Thibault ]
  * copyright: Use https URL for Format.
  * control:
    + Bump Standards-Version to 4.5.1.
    + Add Vcs-* fields.
    + Bump debhelper compat to 12.
  * dirs: Drop unused /usr/bin directory.
  * postinst postrm prerm: Remove trivial maintainer scripts.

  [ Sebastien Badia ]
  * init.d:
    + Move l2tpns args to a default file
    + Added a SystemD unit file
    + Rename init.d file and add missing Description
  * d/copyright:
    + Fix lintian info (unused-license-paragraph)
    + Update Copyright years and authors
    + Update upstream contact/source
  * d/patches:
    + Refresh and add missing DEP-3 headers
    + Refresh patches (remove applied upstream)
  * d/upstream: Added metadata
  * d/rules: Cleanup rules file
  * d/logrotate: Install logrotate file witch dh
  * d/control:
    + Added Julien and Fernando as Uploaders
    + Bump debhelper compat to 13
    + Added Rules-Requires-Root
    + Added missing Pre-Depends
    + Added myself as Uploaders
  * d/watch: Update watch file (according new upstream)

 -- Sebastien Badia <sbadia@debian.org>  Wed, 09 Dec 2020 18:27:45 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,19 @@
 Section: net
 Priority: optional
 Maintainer: Jonathan McDowell <noodles@earth.li>
-Build-Depends: debhelper (>> 8), libcli-dev (>> 1.8.5)
-Standards-Version: 3.9.4.0
+Uploaders: Sebastien Badia <sbadia@debian.org>,
+           Julien Rabier <jrabier@ilico.org>,
+           Fernando Alves <fendo@sameswifi.fr>
+Build-Depends: debhelper-compat (= 13), libcli-dev (>> 1.8.5)
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/debian/l2tpns
+Vcs-Git: https://salsa.debian.org/debian/l2tpns.git
+Rules-Requires-Root: no
 
 Package: l2tpns
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: layer 2 tunnelling protocol network server (LNS)
  l2tpns is a daemon designed to terminate large volumes of layer 2
  tunnelling protocol (RFC 2661: L2TP) sessions.

## l2tpns 2.3.3

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 OPTIM += -O3
 
 CC = gcc
-LD = gcc
+LD = $(CC)
 INCLUDES = -I.
 CPPFLAGS = $(INCLUDES) $(DEFINES)
 CFLAGS = -Wall -Wformat-security $(OPTIM)
@@ -52,8 +52,8 @@
 
 depend:
 	(sed -n 'p; /^## Dependencies: (autogenerated) ##/q' Makefile && \
-	    gcc -MM $(CPPFLAGS) $(OBJS:.o=.c) && \
-	    gcc -MM $(CPPFLAGS) $(PLUGINS:.so=.c) | sed 's/\.o/.so/') >Makefile.tmp
+	    $(CC) -MM $(CPPFLAGS) $(OBJS:.o=.c) && \
+	    $(CC) -MM $(CPPFLAGS) $(PLUGINS:.so=.c) | sed 's/\.o/.so/') >Makefile.tmp
 	mv Makefile Makefile.bak
 	mv Makefile.tmp Makefile
 
@@ -73,9 +73,9 @@
 	$(INSTALL) -m 0755 l2tpns $(DESTDIR)$(bindir)/l2tpns
 	$(INSTALL) -m 0755 nsctl $(DESTDIR)$(bindir)/nsctl
 
-	$(INSTALL) -m 0644 Docs/startup-config.5 $(DESTDIR)$(man5dir)/startup-config.5
-	$(INSTALL) -m 0644 Docs/l2tpns.8 $(DESTDIR)$(man8dir)/l2tpns.8
-	$(INSTALL) -m 0644 Docs/nsctl.8 $(DESTDIR)$(man8dir)/nsctl.8
+	$(INSTALL) -m 0644 docs/manpages/startup-config.5 $(DESTDIR)$(man5dir)/startup-config.5
+	$(INSTALL) -m 0644 docs/manpages/l2tpns.8 $(DESTDIR)$(man8dir)/l2tpns.8
+	$(INSTALL) -m 0644 docs/manpages/nsctl.8 $(DESTDIR)$(man8dir)/nsctl.8
 
 	gzip --best --force $(DESTDIR)$(man5dir)/*.5 $(DESTDIR)$(man8dir)/*.8

=== test/Makefile ===
CFLAGS = -g -Wall -W -std=c99 -pedantic
TARGETS = bounce generateload radius

all: $(TARGETS)
clean:
	rm -f $(TARGETS)

../md5.o: ../md5.c ../md5.h
	$(MAKE) -C .. md5.o

radius: radius.c ../md5.o

=== debian/changelog ===
l2tpns (2.3.3-2) unstable; urgency=medium

  [ Sebastien Badia ]
  * d/gbp: Added configuration
  * d/patches: Update DEP-3 headers

  [ Julien Rabier ]
  * Update Uploader's e-mail address
  * Backport patch to systemd unit from upstream

 -- Sebastien Badia <sbadia@debian.org>  Mon, 08 Mar 2021 23:32:16 +0100

l2tpns (2.3.3-1) unstable; urgency=medium

  [ Julien Rabier ]
  * fix hardening patch following changes upstream in 2.3.2

  [ Sebastien Badia ]
  * New upstream version 2.3.3

 -- Sebastien Badia <sbadia@debian.org>  Sat, 06 Feb 2021 01:11:00 +0100

l2tpns (2.3.1-2) unstable; urgency=medium

  * d/control: Update maintainer (team), many thanks Jonathan

 -- Sebastien Badia <sbadia@debian.org>  Tue, 15 Dec 2020 10:26:43 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: l2tpns
 Section: net
 Priority: optional
-Maintainer: Jonathan McDowell <noodles@earth.li>
+Maintainer: Debian l2tpns Packaging Team <team+debian-l2tpns@tracker.debian.org>
 Uploaders: Sebastien Badia <sbadia@debian.org>,
-           Julien Rabier <jrabier@ilico.org>,
+           Julien Rabier <julien@ilico.org>,
            Fernando Alves <fendo@sameswifi.fr>
 Build-Depends: debhelper-compat (= 13), libcli-dev (>> 1.8.5)
 Standards-Version: 4.5.1

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath
DPKG_EXPORT_BUILDFLAGS = 1

%:
	dh $@

=== debian/watch ===
# http://sf.net/l2tpns/l2tpns-(.*)\.tar\.gz
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/l2tpns.*\.tar\.gz/l2tpns-$1\.tar\.gz/g \
  https://code.ffdn.org/l2tpns/l2tpns/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*

## l2tpns 2.4.1

=== debian/changelog ===
l2tpns (2.4.1-5) unstable; urgency=medium

  * Upload to unstable.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 09 Oct 2025 22:18:44 +0200

l2tpns (2.4.1-4) experimental; urgency=low

  * Set upstream metadata fields: Bug-Submit.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).
  * Update standards version to 4.6.2, no changes needed.
  * control: Make linux-any.
  * patches/git-slow-radius: Try to fix IP pool exhaustion due to slow RADIUS
    server.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 30 Jul 2025 00:10:52 +0000

l2tpns (2.4.1-3) unstable; urgency=medium

  * patches/needrestart: Add needrestart file.
  * rules: Do not stop on upgrade, so the administrator can restart at will.
  * patches/tmpfiles,tmpfiles.legacy: Make sure that the acct directory exists
    on bootup.
  * watch: Use api to get tags.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 31 Mar 2025 23:17:12 +0200

l2tpns (2.4.1-2) unstable; urgency=medium

  * l2tpns.init.d: Depend on $network to make sure it's finished initializing
    before watching for master heartbeats.
  * control: Add myself as uploader.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 24 Dec 2023 15:21:07 +0100

l2tpns (2.4.1-1) unstable; urgency=medium

  [ Samuel Thibault ]
  * New upstream version 2.4.1
  * d/patches/01-harden-compile.patch: Pass -shared last to avoid conflicting
    with -fpie.
  * Enable diffoscope in reprotest CI
  * control: Make Multi-Arch: foreign.

  [ Sebastien Badia ]
  * New upstream version 2.4.0
  * Bump Standards-Version to 4.6.1 (no changes needed)

 -- Samuel Thibault <sthibault@debian.org>  Sat, 17 Sep 2022 21:20:42 +0200

=== debian/rules ===
--- 
+++ 
@@ -5,3 +5,6 @@
 
 %:
 	dh $@
+
+override_dh_installsystemd:
+	dh_installsystemd --no-stop-on-upgrade

=== debian/watch ===
version=4
opts="pagemangle=s!"name":"(v?@ANY_VERSION@)"!<a href="https://code.ffdn.org/@PACKAGE@/@PACKAGE@/-/archive/$1/@PACKAGE@-$1.tar.bz2">!g" \
https://code.ffdn.org/api/v4/projects/@PACKAGE@%2F@PACKAGE@/repository/tags \
https://code.ffdn.org/@PACKAGE@/@PACKAGE@/.*/@PACKAGE@-v?@ANY_VERSION@@ARCHIVE_EXT@

## l2tpns 2.5.0

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 DESTDIR =
 bindir = /usr/sbin
 etcdir = /etc/l2tpns
+needrestartdir = /etc/needrestart/conf.d
 libdir = /usr/lib/l2tpns
 man5dir = /usr/share/man/man5
 man8dir = /usr/share/man/man8
@@ -43,12 +44,17 @@
 DEFINES += -DBGP
 OBJS += bgp.o
 
-all: programs plugins
+GIT_VERSION=$(shell git describe --abbrev=0)
+
+all: programs plugins doc
 programs: $(PROGRAMS)
 plugins: $(PLUGINS)
+doc:
+	$(MAKE) -C docs
 
 clean:
 	rm -f *.o test/*.o $(PROGRAMS) $(PLUGINS) Makefile.tmp Makefile.bak
+	$(MAKE) -C docs clean
 
 depend:
 	(sed -n 'p; /^## Dependencies: (autogenerated) ##/q' Makefile && \
@@ -77,6 +83,9 @@
 	$(INSTALL) -m 0644 docs/manpages/l2tpns.8 $(DESTDIR)$(man8dir)/l2tpns.8
 	$(INSTALL) -m 0644 docs/manpages/nsctl.8 $(DESTDIR)$(man8dir)/nsctl.8
 
+	$(INSTALL) -d $(DESTDIR)$(needrestartdir)
+	$(INSTALL) -m 0644 needrestart.conf $(DESTDIR)$(needrestartdir)/l2tpns.conf
+
 	gzip --best --force $(DESTDIR)$(man5dir)/*.5 $(DESTDIR)$(man8dir)/*.8
 
 	@for config in startup-config users ip_pool; \
@@ -104,6 +113,9 @@
 		echo mknod /dev/net/tun c 10 200; \
 		mknod /dev/net/tun c 10 200; \
 	fi
+
+dist:
+	git archive -o ../l2tpns-$(GIT_VERSION).tgz --prefix l2tpns-$(GIT_VERSION)/ HEAD
 
 .PHONY: all clean depend install

=== docs/Makefile ===
ifeq (,$(shell command -v pandoc))
all:
clean:
else

# Source documentation in markdown lives in the src/ folder (html and manpages).
# This is what you should edit if you want to make changes to the documentation.
# From these sources, this script generates actual manpages and general
# documentation in html using pandoc.

HTML_MD = $(wildcard src/html/*.md)
MAN_MD = $(wildcard src/man/*.md)

HTML_HTML = $(patsubst src/html/%.md,html/%.html,$(HTML_MD))
MAN_MAN = $(patsubst src/man/%.md,manpages/%,$(MAN_MD))

all: $(HTML_HTML) $(MAN_MAN)

html/%.html: src/html/%.md
	pandoc -f markdown -t html $< > $@
	echo $@ successfully built in docs/html directory

manpages/%: src/man/%.md
	pandoc -s -t man $< -o $@
	echo $@ successfully built in docs/manpages directory

clean:
	rm -f html/*.html manpages/*.[58]
endif

=== debian/changelog ===
l2tpns (2.5.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1116009)
  * watch: Leverage version 5.
  * patches/git-slow-radius: Upstreamed.
  * patches/needrestart: Upstreamed.
  * patches/tmpfiles: Upstreamed.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 03 Nov 2025 01:32:40 +0100

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,17 @@
 Maintainer: Debian l2tpns Packaging Team <team+debian-l2tpns@tracker.debian.org>
 Uploaders: Sebastien Badia <sbadia@debian.org>,
            Julien Rabier <julien@ilico.org>,
-           Fernando Alves <fendo@sameswifi.fr>
-Build-Depends: debhelper-compat (= 13), libcli-dev (>> 1.8.5)
-Standards-Version: 4.5.1
+           Fernando Alves <fendo@sameswifi.fr>,
+           Samuel Thibault <sthibault@debian.org>
+Build-Depends: debhelper-compat (= 13), libcli-dev
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/l2tpns
 Vcs-Git: https://salsa.debian.org/debian/l2tpns.git
 Rules-Requires-Root: no
 
 Package: l2tpns
-Architecture: any
+Architecture: linux-any
+Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: layer 2 tunnelling protocol network server (LNS)

=== debian/watch ===
Version: 5

Source: https://code.ffdn.org/l2tpns/l2tpns
Mode: gitlab
Matching-Pattern: @ANY_VERSION@
